/* ===========================================================================
                     RECURSIVE TOWERS OF HANOI (TWO CALLS)
For this program see: Pettorossi, A.: "Towers of Hanoi problems: deriving
iterative solutions by program transformation BIT Vol.25 (1985), 327-334.
=========================================================================== */
#include  <iostream.h>
#include  <string>   // not <string.h>. File needed for using strings.
const int Initial=2; // it should be >=0
const int Final=3;   // it should be >=Initial
/*----------------------------------------------------------------------------
Initial and Final are the number of disks for which the initial and final
runs are constructed.
--------------------------------------------------------------------------- */
string hanoi(int n, string pegA, string pegB, string pegC)
{if (n==0) {return " ";} else
    {return hanoi(n-1,pegA,pegC,pegB) + pegA + pegB +
            hanoi(n-1,pegC,pegB,pegA);};}
void main()
{for (int i=Initial; i<=Final; i++)
      {string moves=hanoi(i,"A","B","C");
      cout << "Moves for Hanoi from peg A to peg B of "<<i<<" disks:\n";
      cout << moves << "\n\n";};
}
/* input:   output:
------------------------------------------------------------------------------
            Moves for Hanoi from peg A to peg B of 2 disks:
             AC AB CB

            Moves for Hanoi from peg A to peg B of 3 disks:
             AB AC BC AB CA CB AB
--------------------------------------------------------------------------- */
